﻿using UnityEngine;
using Random = UnityEngine.Random;

namespace VRAdultFun
{
    partial class EmotionEngine
    {
        private class LCasual : State
        {

            public override void OnEnter()
            {
				Duration = 0.001f;
				if (enableCasual)
				{
					currentLook = "Casual";
					sexActionNeckX = 0.0f;
					//LogError("Casual");
					if (interestClock <= 0.0f)
					{
						shoulderUp = Random.Range(0.0f,0.2f);
					}
						peronalityAdjustH = Random.Range(-55.0f, 55.0f) * Mathf.Deg2Rad;
						peronalityAdjustV = Random.Range(-5.0f, 2.0f) * Mathf.Deg2Rad;              //gHeadSpeed = 0.5f;
					if (Random.Range(0.0f, 100.0f) < 35.0f * rollChance)
					{
						//Vector3 cross = Vector3.Cross(chestController.followWhenOff.forward, headController.followWhenOff.forward);
						float headLeftRight = Vector3.SignedAngle (chestController.followWhenOff.forward, headController.followWhenOff.forward, chestController.followWhenOff.up);
						float headUpDown = Vector3.SignedAngle (chestController.followWhenOff.forward, headController.followWhenOff.forward, -chestController.followWhenOff.right);
						gHeadRollTarget = Random.Range(-maxHeadRoll / 7.0f, maxHeadRoll / 7.0f);
						if (headLeftRight > lookDirectAngle)
						{
							gHeadRollTarget = Random.Range(-maxHeadRoll / 7.0f, -0.0f);
						}
						if (headLeftRight < -lookDirectAngle)
						{
							gHeadRollTarget = Random.Range(maxHeadRoll / 7.0f, 0.0f);
						}
						if (headUpDown > lookPeripheralAngle)
						{
							gHeadRollTarget = Random.Range(-maxHeadRoll / 5.0f, maxHeadRoll / 5.0f);
						}
					}
					else
					{
						gHeadRollTarget = 0.0f;
					}
					saccadeAmount = Random.Range(5.0f, 7.0f);
					saccadeClock = 0.0f;
					lookAction = true;
					lookVariation = Random.Range(0.7f, 1.35f);
					browVariation = Random.Range(0.6f, 1.15f);
					eyeVariation = Random.Range(0.8f, 1.25f);
					mouthVariation = Random.Range(0.7f, 1.15f);
					if (Random.Range(0.0f, 100.0f) > 50.0f && morphBrowAction == false)
					{
            browSM.Switch(bRaised);
            if (Random.Range(0.0f, 100.0f) <= 10.0f)
            {
              browSM.Switch(bConcentrate);
            }
            if (Random.Range(0.0f, 100.0f) <= 5.0f)
            {
              browSM.Switch(bLowered);
            }
            if (Random.Range(0.0f, 100.0f) <= 2.0f)
            {
              browSM.Switch(bApprehensive);
            }
					}
					if (Random.Range(0.0f, 100.0f) > Mathf.Lerp(50.0f, 15.0f, pExtraversion) && morphMouthAction == false)
					{
						if (interestValence > 9.0f)
						{
							if (pExtraversion > 75.0f)
							{
								if (smiledlast)
								{
                  mouthSM.Switch(mClosed);
                  if (Random.Range(0.0f, 100.0f) <= 15.0f)
                  {
                    mouthSM.Switch(mOpen);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(2.0f, 6.0f, interestArousal/10.0f))
                  {
                    mouthSM.Switch(mSmirk);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 5.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mSideways);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(5.0f, 10.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mBiteLip);
                  }
								}
								else
								{
                  mouthSM.Switch(mClosed);
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 17.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mSmile);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 15.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mBigSmile);
                  }
                  if (Random.Range(0.0f, 100.0f) <= 15.0f)
                  {
                    mouthSM.Switch(mOpen);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 6.0f, interestArousal/10.0f))
                  {
                    mouthSM.Switch(mSmirk);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 5.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mSideways);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 5.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mBiteLip);
                  }
								}
							}
							else
							{
                  mouthSM.Switch(mClosed);
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 12.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mSmile);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 7.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mBigSmile);
                  }
                  if (Random.Range(0.0f, 100.0f) <= 15.0f)
                  {
                    mouthSM.Switch(mOpen);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 6.0f, interestArousal/10.0f))
                  {
                    mouthSM.Switch(mSmirk);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 5.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mSideways);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 5.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mBiteLip);
                  }
							}
						}
						else
						{
							if (pExtraversion > 75.0f)
							{
								if (smiledlast)
								{
                  mouthSM.Switch(mClosed);
                  if (Random.Range(0.0f, 100.0f) <= 15.0f)
                  {
                    mouthSM.Switch(mOpen);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 5.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mSideways);
                  }
								}
								else
								{
                  mouthSM.Switch(mClosed);
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 7.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mSmile);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 5.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mBigSmile);
                  }
                  if (Random.Range(0.0f, 100.0f) <= 20.0f)
                  {
                    mouthSM.Switch(mOpen);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 5.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mSideways);
                  }
								}
							}
							else
							{
								if (smiledlast)
								{
                  mouthSM.Switch(mClosed);
                  if (Random.Range(0.0f, 100.0f) <= 25.0f)
                  {
                    mouthSM.Switch(mOpen);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 6.0f, interestArousal/10.0f))
                  {
                    mouthSM.Switch(mSmirk);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 5.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mSideways);
                  }
								}
								else
								{
                  mouthSM.Switch(mClosed);
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 7.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mSmile);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 5.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mBigSmile);
                  }
                  if (Random.Range(0.0f, 100.0f) <= 35.0f)
                  {
                    mouthSM.Switch(mOpen);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 5.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mSideways);
                  }
                  if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 5.0f, interestValence/10.0f))
                  {
                    mouthSM.Switch(mBiteLip);
                  }
								}
							}
						}
					}
          eyesSM.Switch(eOpen);
          if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(5.0f, 10.0f, interestValence/10.0f))
          {
            eyesSM.Switch(eFocus);
          }
          if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(10.0f, 20.0f, interestArousal/10.0f))
          {
            eyesSM.Switch(eSquint);
          }
					float rand = Random.Range(0.0f, 100.0f);
					if (rand > 33.0f)
					{
						mLHandStraightenTarget = Random.Range(0.0f, 0.2f);
						mLHandFistTarget = Random.Range(0.0f, 0.5f);
					}
					if (rand < 66.0f)
					{
						mRHandStraightenTarget = Random.Range(0.0f, 0.2f);
						mRHandFistTarget = Random.Range(0.0f, 0.5f);
					}
					Duration = Random.Range(2.0f, 5.0f) * uiExpressionLengthVal;
				}
            }
            public override void OnInterrupt(string parameter)
            {
                OnTimeout();
            }
            public override void OnTimeout()
            {
                lookAction = false;
            }
        }
    }

}