﻿using Random = UnityEngine.Random;
using UnityEngine;

namespace VRAdultFun
{
    partial class EmotionEngine
    {
        private class LFeel : State
        {
            public override void OnEnter()
            {
				Duration = 0.001f;
				if (enableFeel)
				{
					tempFloat = Random.Range(05.0f, Mathf.Lerp(35.0f, 55.0f, interestValence/10.0f));
					if (peronalityAdjustH > 0.0f)
					{
						if (Random.Range(0.0f,100.0f) > 20.0f) //peronalityAdjustH > 0.0f)
						{
							peronalityAdjustH = tempFloat * Mathf.Deg2Rad;
						}
						else
						{
							peronalityAdjustH = -tempFloat * Mathf.Deg2Rad;
						}
					}
					else
					{
						if (Random.Range(0.0f,100.0f) > 80.0f) //peronalityAdjustH > 0.0f)
						{
							peronalityAdjustH = tempFloat * Mathf.Deg2Rad;
						}
						else
						{
							peronalityAdjustH = -tempFloat * Mathf.Deg2Rad;
						}
					}
					peronalityAdjustV = Random.Range(-1.0f, 5.0f) * Mathf.Deg2Rad;
					sexActionNeckX = Random.Range(0.0f,10.0f);
					shoulderUp = Random.Range(0.2f,0.5f);
					currentLook = "Feel";
					//LogError("Feel");
					//gHeadSpeed = 2.0f;
					if (Random.Range(0.0f, 100.0f) < 15.0f * rollChance)
					{
						float headLeftRight = Vector3.SignedAngle (chestController.followWhenOff.forward, headController.followWhenOff.forward, chestController.followWhenOff.up);
						float headUpDown = Vector3.SignedAngle (chestController.followWhenOff.forward, headController.followWhenOff.forward, -chestController.followWhenOff.right);
						gHeadRollTarget = Random.Range(-maxHeadRoll / 2.0f, maxHeadRoll / 2.0f);
						if (headLeftRight > lookDirectAngle)
						{
							gHeadRollTarget = Random.Range(-maxHeadRoll / 3.0f, -maxHeadRoll / 5.0f);
						}
						if (headLeftRight < -lookDirectAngle)
						{
							gHeadRollTarget = Random.Range(maxHeadRoll / 3.0f, maxHeadRoll / 5.0f);
						}
						if (headUpDown > lookPeripheralAngle)
						{
							gHeadRollTarget = Random.Range(-maxHeadRoll / 5.0f, maxHeadRoll / 5.0f);
						}
					}
					saccadeAmount = Random.Range(2.0f, 3.0f);
					//mBrowUpTarget = Random.Range(0.2f, 0.5f);
					saccadeClock = 0.0f;
					lookAction = true;
					lookVariation = Random.Range(0.15f, 0.35f);
					browVariation = Random.Range(0.20f, 0.55f);
					eyeVariation = Random.Range(0.05f, 0.35f);
					mouthVariation = Random.Range(0.25f, 0.35f);
          browSM.Switch(bRaised);
          if (Random.Range(0.0f, 100.0f) <= 5.0f)
          {
            browSM.Switch(bLowered);
          }
          if (Random.Range(0.0f, 100.0f) <= 20.0f)
          {
            browSM.Switch(bApprehensive);
          }
          if (Random.Range(0.0f, 100.0f) <= 30.0f)
          {
            browSM.Switch(bConcentrate);
          }
          if (Random.Range(0.0f, 100.0f) <= 5.0f)
          {
            browSM.Switch(bOneRaise);
          }
          mouthSM.Switch(mOpen);
          if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 15.0f, interestValence/10.0f))
          {
            mouthSM.Switch(mSmile);
          }
          if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(10.0f, 20.0f, interestArousal/10.0f))
          {
            mouthSM.Switch(mSmirk);
          }
          if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(5.0f, 15.0f, interestValence/10.0f))
          {
            mouthSM.Switch(mBiteLip);
          }
          if (Random.Range(0.0f, 100.0f) <= 15.0f)
          {
            mouthSM.Switch(mClosed);
          }
          if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(0.0f, 5.0f, interestValence/10.0f))
          {
            mouthSM.Switch(mSideways);
          }
          eyesSM.Switch(eOpen);
          if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(10.0f, 50.0f, interestArousal/10.0f))
          {
            eyesSM.Switch(eClosed);
          }
          if (Random.Range(0.0f, 100.0f) <= Mathf.Lerp(5.0f, 10.0f, interestValence/10.0f))
          {
            eyesSM.Switch(eFocus);
          }
					float rand = Random.Range(0.0f, 100.0f);
					if (rand > 33.0f)
					{
						mLHandStraightenTarget = Random.Range(0.0f, 0.4f);
						mLHandFistTarget = Random.Range(0.0f, 0.4f);
					}
					if (rand < 66.0f)
					{
						mRHandStraightenTarget = Random.Range(0.0f, 0.4f);
						mRHandFistTarget = Random.Range(0.0f, 0.4f);
					}
					Duration = Random.Range(1.0f, 2.0f) * uiExpressionLengthVal;
				}
            }
            public override void OnInterrupt(string parameter)
            {
                OnTimeout();
            }
            public override void OnTimeout()
            {
                lookAction = false;
            }
        }
    }

}